//+------------------------------------------------------------------+
//|                                       Custom Stochastic-X8.4.mq4 |
//|     Make in Russia by lukas1 aka Victor Lukashuk / lukas1@ngs.ru |
//+------------------------------------------------------------------+
//+++======================================================================+++
//+++           Stochastic-X8.4 vs Index +Matrix TT [x15x9x15]             +++
//+++======================================================================+++
#property copyright "  Tankk,  12  july  2016,  http://forexsystems.ru/" 
#property link      "http://forexsystemsru.com/indikatory-foreks-f41/" 

#property description "Make in Russia by lukas1 aka Victor Lukashuk / lukas1@ngs.ru" 
#property description "   "
#property description "Stochastic Oscillator           .    .    %K.   %D -     %K."
#property description "  , ,      ,  Stochastic        ."
#property description " 15 , ,    :))  :))"
//#property version   "15.00"
#property indicator_separate_window
#property indicator_buffers 10

#property indicator_color1   Brown       //DarkOrchid   //Violet
#property indicator_color2   SlateBlue   //RoyalBlue    //Blue
#property indicator_color3   Tomato      //OrangeRed    //Red
#property indicator_color4   SeaGreen
#property indicator_color5   Gold        //DarkOrange  
#property indicator_color6   Magenta     //SeaGreen
#property indicator_color7   DeepSkyBlue   //DodgerBlue
#property indicator_color8   Red         //White
#property indicator_color9   White
#property indicator_color10  ForestGreen  //LimeGreen

#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  1
#property indicator_width7  1
#property indicator_width8  2
#property indicator_width9  2
#property indicator_width10 2

#property indicator_level1  100
#property indicator_level2  50   //35
#property indicator_level3  15
#property indicator_level4  -15
#property indicator_level5  -50   //-35
#property indicator_level6  -100

#property indicator_levelcolor DarkSlateGray // SteelBlue //C'60,61,62' // 
#property indicator_levelstyle STYLE_DOT

//#property indicator_minimum -150
//#property indicator_maximum  150

enum calcIndex { NoIndex, AC, ADX, AO, BRBL, CCI, DMR, FRC, MACD, OsMA, MFI, MMNT, RSI, RVI, STO, WPR };
enum arrt { NoArrows, MatrixZero, StochAngle, StochCloseOpen, StochCrossSignal, StochCrossOverSBL, SignalCrossOverSBL, IndexCrossStoch, IndexCrossSignal, IndexCrossOverSBL };   
enum mtxt { NoMatrix, mxAC, mxADX, mxAO, mxBRBL, mxCCI, mxCCD, mxDMR, mxFRC, mxMA, mxDPO, mxMFI, mxMMNT, mxRSI, mxRVI, mxWPR };
//+++======================================================================+++
//+++                 Custom indicator input parameters                    +++
//+++======================================================================+++

extern int                 History  =  0;   //   
extern bool              ShowHisto  =  true,
                       ShowStochX8  =  true;
extern int                 Stoch_K  =  13,   //5,    //parameter of D stoch.
                           Stoch_D  =  1,    //parameter of signal line.
                           Stoch_S  =  5;    //parameter of S stoch.
extern ENUM_MA_METHOD    StochMode  =  MODE_LWMA;
extern ENUM_STO_PRICE   StochPrice  =  STO_LOWHIGH;    
extern int              StochShift  =  0;
extern double                 Koef  =  1.2,
                        OverBought  =  50,   
                          OverSold  = -50;

extern bool             ShowSignal  =  true;
extern int                SignalMA  =  13;   //5;
extern ENUM_MA_METHOD   SignalMode  =  MODE_LWMA;
extern int             SignalShift  =  0;

extern calcIndex           ShowIndex  =  CCI;
extern int               IndexPeriod  =  13,
                           IndexSlow  =  45;           
extern ENUM_MA_METHOD      IndexMode  =  MODE_LWMA;
extern ENUM_APPLIED_PRICE IndexPrice  =  PRICE_TYPICAL;
extern int                IndexShift  =  0;

extern mtxt                ShowMatrix  =  mxMA;
extern int               MatrixPeriod  =  45;
extern ENUM_MA_METHOD      MatrixMode  =  MODE_LWMA;
extern ENUM_APPLIED_PRICE MatrixPrice  =  PRICE_CLOSE;   
extern int                MatrixShift  =  0;
extern int                     CodeUP  =  59,   //110 //167 //233 //241
                               CodeDN  =  59;   //110 //167 //234 //242
                               
extern arrt               ShowArrows  =  IndexCrossStoch;  
extern color                 ArrowUP  =  LightCyan,   //Lavender,    //FireBrick,       //Red,
                             ArrowDN  =  Red;        //Magenta;     //DarkGreen;       //Lime
extern int                 ArrowSize  =  1;   
extern int                  ArrowGap  =  3,            //  High/Low  (4- )     
                               ArrUP  =  233,   //225
                               ArrDN  =  234;   //226
                               
extern bool          AlertsMessage  =  true,   //false,    
                       AlertsSound  =  true,   //false,
                       AlertsEmail  =  false,
                      AlertsMobile  =  false;
extern string            SoundFile  =  "news.wav";   //"stops.wav"   //"alert2.wav"   //"expert.wav"

//+++======================================================================+++
//+++                     Custom indicator buffers                         +++
//+++======================================================================+++
double D10,D11,D12,D13,D14,D15,D16,D17;
double K10,K11,K12,K13,K14,K15,K16,K17;
double S10,S11,S12,S13,S14,S15,S16,S17;
double ExtBufferDN[],ExtBufferUP[];
double CLDN[],CLUP[],CO[];
double MatrixDN[], MatrixUP[];
double Buf7[], SignalBuffer[], IndexBuffer[];   int TimeBar=0; 
double First1[], First2[], Secnd1[], Secnd2[];
//+++======================================================================+++
//+++              Custom indicator initialization function                +++
//+++======================================================================+++

int init()
{
   K10=Stoch_K;    K11=K10*Koef;   K12=K11*Koef;   K13=K12*Koef;
   K14=K13*Koef;   K15=K14*Koef;   K16=K15*Koef;   K17=K16*Koef;
   
   D10=Stoch_D;    D11=D10*Koef;   D12=D11*Koef;   D13=D12*Koef;
   D14=D13*Koef;   D15=D14*Koef;   D16=D15*Koef;   D17=D16*Koef;
   
   S10=Stoch_S;    S11=S10*Koef;   S12=S11*Koef;   S13=S12*Koef;
   S14=S13*Koef;   S15=S14*Koef;   S16=S15*Koef;   S17=S16*Koef;
//+++======================================================================+++

   IndicatorBuffers(14);   IndicatorDigits(Digits-3);   if (Digits==2 || Digits==3) IndicatorDigits(Digits-1);
   
   SetIndexBuffer(0,ExtBufferDN);
   SetIndexBuffer(1,ExtBufferUP);
   SetIndexBuffer(2,CLDN);
   SetIndexBuffer(3,CLUP); 
   SetIndexBuffer(4,CO);       
   SetIndexBuffer(5,MatrixDN);
   SetIndexBuffer(6,MatrixUP); 
   SetIndexBuffer(7,Buf7);
   SetIndexBuffer(8,SignalBuffer);       
   SetIndexBuffer(9,IndexBuffer);    
   
   SetIndexBuffer(10,First1); 
   SetIndexBuffer(11,First2);       
   SetIndexBuffer(12,Secnd1);
   SetIndexBuffer(13,Secnd2);   
//+++======================================================================+++

   //int HLT=DRAW_NONE;   if (ShowHisto) HLT=DRAW_HISTOGRAM; 
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);  
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_HISTOGRAM);
   
   SetIndexStyle(5,DRAW_ARROW);   SetIndexArrow(5,CodeUP);   
   SetIndexStyle(6,DRAW_ARROW);   SetIndexArrow(6,CodeDN);   

   if (ShowStochX8) SetIndexStyle(7,DRAW_LINE);   else SetIndexStyle(7,DRAW_NONE);        
   SetIndexStyle(8,DRAW_LINE);
   SetIndexStyle(9,DRAW_LINE);
//+++======================================================================+++

   if (ShowHisto)  SetIndexLabel(0,"DN");        else SetIndexLabel(0,NULL);
   if (ShowHisto)  SetIndexLabel(1,"UP");        else SetIndexLabel(1,NULL);
   if (ShowHisto)  SetIndexLabel(2,"CLDN");      else SetIndexLabel(2,NULL); 
   if (ShowHisto)  SetIndexLabel(3,"CLUP");      else SetIndexLabel(3,NULL);
   if (ShowHisto)  SetIndexLabel(4,"CO");        else SetIndexLabel(4,NULL);
   if (ShowMatrix!=NoMatrix) SetIndexLabel(5,"MatrixDN ["+IntegerToString(MatrixPeriod)+"]");   else SetIndexLabel(5,NULL);
   if (ShowMatrix!=NoMatrix) SetIndexLabel(6,"MatrixUP ["+IntegerToString(MatrixPeriod)+"]");   else SetIndexLabel(6,NULL);
   SetIndexLabel(7,"StochX8  ["+IntegerToString(Stoch_K)+","+IntegerToString(Stoch_D)+","+IntegerToString(Stoch_S)+"]");
   if (ShowSignal) SetIndexLabel(8,"SignalMA   ["+IntegerToString(SignalMA)+"]");     else SetIndexLabel(8,NULL);
   if (ShowIndex!=NoIndex)    SetIndexLabel(9,+EnumToString(ShowIndex)+" ["+IntegerToString(IndexPeriod)+","+IntegerToString(IndexSlow)+"]");   else SetIndexLabel(9,NULL);
   
//+++======================================================================+++
//+++           Stochastic-X8.4 vs Index +Matrix TT [x15x9x15]             +++
//+++======================================================================+++

   SetIndexShift(0,StochShift);  
   SetIndexShift(1,StochShift);     
   SetIndexShift(2,StochShift);     
   SetIndexShift(3,StochShift);   
   SetIndexShift(4,StochShift);  
   SetIndexShift(5,MatrixShift);   
   SetIndexShift(6,MatrixShift);  
   SetIndexShift(7,StochShift);  
   SetIndexShift(8,SignalShift);  
   SetIndexShift(9,IndexShift);  
   
   SetIndexDrawBegin(0,StochShift+Stoch_D);     
   SetIndexDrawBegin(1,StochShift+Stoch_D);     
   SetIndexDrawBegin(2,StochShift+Stoch_D);  
   SetIndexDrawBegin(3,StochShift+Stoch_D);  
   SetIndexDrawBegin(4,StochShift+Stoch_D);
   SetIndexDrawBegin(5,MatrixShift+MatrixPeriod);  
   SetIndexDrawBegin(6,MatrixShift+MatrixPeriod);
   SetIndexDrawBegin(7,StochShift+Stoch_D);   
   SetIndexDrawBegin(8,SignalShift+SignalMA);   
   SetIndexDrawBegin(9,IndexShift+IndexPeriod);   
   
//---- indicator short name
   string sim=StringSetChar("",0,164);
   if (ShowSignal)           string labelM = " -> SigMA["+IntegerToString(SignalMA)+"]";
   if (ShowIndex!=NoIndex)   string labelC = " + "+EnumToString(ShowIndex)+ "["+IntegerToString(IndexPeriod)+"]";
   if (ShowMatrix)           string labelX = " + "+EnumToString(ShowMatrix)+"["+IntegerToString(MatrixPeriod)+"]";
   IndicatorShortName("StochX8 ["+IntegerToString(Stoch_K)+","+IntegerToString(Stoch_D)+","+IntegerToString(Stoch_S)+"] "+sim+DoubleToString(Koef,2)+labelM+labelC+labelX);
   
//---- initialization done
return(0);
}
//+++======================================================================+++
//+++              Custom indicator deinitialization function              +++
//+++======================================================================+++
int deinit() 
{
   ARROWS_DELETE();
   return(0);
}

void ARROWS_DELETE()   //EnumToString(ShowArrows)+
{
   string name;   string pref="Stoch ["+IntegerToString(Stoch_K)+","+IntegerToString(Stoch_S)+"] vs "+EnumToString(ShowIndex)+" ["+IntegerToString(IndexPeriod)+"]_";
   for (int a=ObjectsTotal()-1; a>=0; a--) 
     {
      name=ObjectName(a);
      if (StringSubstr(name,0,StringLen(pref))==pref) ObjectDelete(name);
     }
}
//+++======================================================================+++
//+++                 Custom indicator iteration function                  +++
//+++======================================================================+++

int start()
{
    int i, counted_bars=IndicatorCounted();
    if(counted_bars<0)    return(-1);
      
       if(History < 1)     History = Bars;
       if(counted_bars > 0)    counted_bars -= 0;
          
          int limit = MathMin(History-counted_bars,History-1);  
          if(limit<=0) limit=1;          
//+++======================================================================+++

    double m1,m2,m3,m4,m5,m6,m7,m8;
  
    for(i=0; i<limit; i++)
      {
       m1 = 2* NormalizeDouble(iStochastic(NULL,0,K10,D10,S10,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m2 = 2* NormalizeDouble(iStochastic(NULL,0,K11,D11,S11,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m3 = 2* NormalizeDouble(iStochastic(NULL,0,K12,D12,S12,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m4 = 2* NormalizeDouble(iStochastic(NULL,0,K13,D13,S13,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m5 = 2* NormalizeDouble(iStochastic(NULL,0,K14,D14,S14,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m6 = 2* NormalizeDouble(iStochastic(NULL,0,K15,D15,S15,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m7 = 2* NormalizeDouble(iStochastic(NULL,0,K16,D16,S16,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m8 = 2* NormalizeDouble(iStochastic(NULL,0,K17,D17,S17,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       
       Buf7[i] = (m1+m2+m3+m4+m5+m6+m7+m8)/8;
      }
//+++======================================================================+++
//+++======================================================================+++

         double JPY=100000;   if (Digits==2 || Digits==3) JPY=1000;
         double JPP=10000;   if (Digits==2 || Digits==3) JPP=100;
         double JP =1000;   if (Digits==2 || Digits==3) JP=10;
         double JT =100;   if (Digits==2 || Digits==3) JT=1;
         double JJ =10;   if (Digits==2 || Digits==3) JJ=0.1;
//+++======================================================================+++

     for(i=limit; i>=0; i--) 
       {
        if (ShowHisto && Buf7[i]<Buf7[i+1]) { ExtBufferDN[i]=Buf7[i];  ExtBufferUP[i]=0; }
        if (ShowHisto && Buf7[i]>Buf7[i+1]) { ExtBufferUP[i]=Buf7[i];  ExtBufferDN[i]=0; }  
     
        if (ShowHisto && Close[i]<Open[i])  { CLDN[i]=Buf7[i]/2;  CLUP[i]=0;  CO[i]=0;   }
        if (ShowHisto && Close[i]>Open[i])  { CLUP[i]=Buf7[i]/2;  CLDN[i]=0;  CO[i]=0;   } 
        if (ShowHisto && Close[i]==Open[i]) { CO[i]=Buf7[i]/2;    CLDN[i]=0;  CLUP[i]=0; }
//+++======================================================================+++

        if (ShowSignal) SignalBuffer[i] = iMAOnArray(Buf7,0,SignalMA,0,SignalMode,i);   else SignalBuffer[i]=EMPTY_VALUE;     
//+++======================================================================+++

        if (ShowIndex==NoIndex)  IndexBuffer[i]=EMPTY_VALUE;    //enum calcIndex { NoIndex, AC, ADX, AO, BRBL, CCI, DMR, FRC, MACD, OsMA, MFI, MMNT, RSI, RVI, STO, WPR};   
        
        if (ShowIndex==AC)       IndexBuffer[i] = JPY* iAC(NULL,0,i);    
        if (ShowIndex==ADX)      IndexBuffer[i] = (10* (iADX(NULL,0,IndexPeriod,IndexPrice,MODE_PLUSDI,i) - iADX(NULL,0,IndexPeriod,IndexPrice,MODE_MINUSDI,i))) /2;   // Koef
        if (ShowIndex==AO)       IndexBuffer[i] = 2*JPP* iAO(NULL,0,i);    
        if (ShowIndex==BRBL)     IndexBuffer[i] = 2*JPP* ((iBearsPower(NULL,0,IndexPeriod,IndexPrice,i) + iBullsPower(NULL,0,IndexPeriod,IndexPrice,i))/2);
        if (ShowIndex==CCI)      IndexBuffer[i] = iCCI(NULL,0,IndexPeriod,IndexPrice,i) /2;   // Koef
        if (ShowIndex==DMR)      IndexBuffer[i] = 200* (NormalizeDouble(iDeMarker(NULL,0,IndexPeriod,i)-0.5,Digits+1));
        if (ShowIndex==FRC)      IndexBuffer[i] = JT* iForce(NULL,0,IndexPeriod,IndexMode,IndexPrice,i);
        if (ShowIndex==MACD)     IndexBuffer[i] = 2*JPP* iMACD(NULL,0,IndexPeriod,IndexSlow,1,IndexPrice,MODE_MAIN,i);
        if (ShowIndex==OsMA)     IndexBuffer[i] = 2*JPP* iOsMA(NULL,0,IndexPeriod,IndexSlow,SignalMA,IndexPrice,i);
        if (ShowIndex==MFI)      IndexBuffer[i] = 2* NormalizeDouble(iMFI(NULL,0,IndexPeriod,i)-50,Digits+1);    
        if (ShowIndex==MMNT)     IndexBuffer[i] = 200* NormalizeDouble(iMomentum(NULL,0,IndexPeriod,IndexPrice,i)-100,Digits+1);
        if (ShowIndex==RSI)      IndexBuffer[i] = 2* NormalizeDouble(iRSI(NULL,0,IndexPeriod,IndexPrice,i)-50,Digits+1);    
        if (ShowIndex==RVI)      IndexBuffer[i] = 200* iRVI(NULL,0,IndexPeriod,MODE_MAIN,i);
        if (ShowIndex==STO)      IndexBuffer[i] = 2* NormalizeDouble(iStochastic(NULL,0,IndexPeriod,1,IndexSlow,IndexMode,STO_LOWHIGH,MODE_MAIN,i)-50,Digits+1);
        if (ShowIndex==WPR)      IndexBuffer[i] = 2* NormalizeDouble(iWPR(NULL,0,IndexPeriod,i)+50,Digits+1);
//+++======================================================================+++
//+++           Stochastic-X8.4 vs Index +Matrix TT [x15x9x15]             +++
//+++======================================================================+++
//enum mtxt { NoMatrix, mxAC, mxADX, mxAO, mxBRBL, mxCCI, mxCCD, mxDMR, mxFRC, mxMA, mxDPO, mxMFI, mxMMNT, mxRSI, mxRVI, mxWPR };

    if (ShowMatrix!=NoMatrix) { MatrixDN[i]=3;   MatrixUP[i]=-3; }   double Matrix;       
                                                                                                 //iClose(NULL,0,i)
    if (ShowMatrix==mxMA)    { Matrix = iMA(NULL,0,MatrixPeriod,0,MatrixMode,MatrixPrice,i);   if (Close[i] > Matrix) MatrixDN[i] = EMPTY_VALUE;   if (Close[i] < Matrix) MatrixUP[i] = EMPTY_VALUE; }   

    if (ShowMatrix==mxAC)    { Matrix = iAC(NULL,0,i); }     
    if (ShowMatrix==mxADX)   { Matrix = iADX(NULL,0,MatrixPeriod,MatrixPrice,MODE_PLUSDI,i) - iADX(NULL,0,MatrixPeriod,MatrixPrice,MODE_MINUSDI,i); }
    if (ShowMatrix==mxAO)    { Matrix = iAO(NULL,0,i); }  
    if (ShowMatrix==mxBRBL)  { Matrix = (iBearsPower(NULL,0,MatrixPeriod,MatrixPrice,i) + iBullsPower(NULL,0,MatrixPeriod,MatrixPrice,i))/2; }  
    if (ShowMatrix==mxCCI)   { Matrix = iCCI(NULL,0,MatrixPeriod,MatrixPrice,i); }  
    if (ShowMatrix==mxCCD)   { Matrix = iCCI(NULL,0,MatrixPeriod*1.5,MatrixPrice,i) - iCCI(NULL,0,MatrixPeriod,MatrixPrice,i); }  
    if (ShowMatrix==mxDMR)   { Matrix = iDeMarker(NULL,0,MatrixPeriod,i);   if (Matrix > 0.5) MatrixDN[i] = EMPTY_VALUE;   if (Matrix < 0.5) MatrixUP[i] = EMPTY_VALUE; }  
    if (ShowMatrix==mxFRC)   { Matrix = iForce(NULL,0,MatrixPeriod,MatrixMode,MatrixPrice,i); }  
    if (ShowMatrix==mxDPO)   { Matrix = Close[i] - iMA(NULL,0,MatrixPeriod,(MatrixPeriod/2)+1,MatrixMode,MatrixPrice,i); }
    if (ShowMatrix==mxMFI)   { Matrix = iMFI(NULL,0,MatrixPeriod,i);   if (Matrix > 50) MatrixDN[i] = EMPTY_VALUE;   if (Matrix < 50) MatrixUP[i] = EMPTY_VALUE; }  
    if (ShowMatrix==mxMMNT)  { Matrix = iMomentum(NULL,0,MatrixPeriod,MatrixPrice,i);   if (Matrix > 100) MatrixDN[i] = EMPTY_VALUE;   if (Matrix < 100) MatrixUP[i] = EMPTY_VALUE; }  
    if (ShowMatrix==mxRSI)   { Matrix = iRSI(NULL,0,MatrixPeriod,MatrixPrice,i);   if (Matrix > 50) MatrixDN[i] = EMPTY_VALUE;   if (Matrix < 50) MatrixUP[i] = EMPTY_VALUE; }  
    if (ShowMatrix==mxRVI)   { Matrix = iRVI(NULL,0,MatrixPeriod,MODE_MAIN,i); }
    if (ShowMatrix==mxWPR)   { Matrix = iWPR(NULL,0,MatrixPeriod,i);   if (Matrix > -50) MatrixDN[i] = EMPTY_VALUE;   if (Matrix < -50) MatrixUP[i] = EMPTY_VALUE; }  
    
    if (ShowMatrix==mxAC || ShowMatrix==mxADX || ShowMatrix==mxAO || ShowMatrix==mxBRBL || ShowMatrix==mxCCI || ShowMatrix==mxCCD || ShowMatrix==mxFRC || ShowMatrix==mxDPO || ShowMatrix==mxRVI)
     { if (Matrix > 0)  MatrixDN[i] = EMPTY_VALUE;   if (Matrix < 0)  MatrixUP[i] = EMPTY_VALUE; }
//+++======================================================================+++
//+++           Stochastic-X8.4 vs Index +Matrix TT [x15x9x15]             +++
//+++======================================================================+++
//enum arrt { No_Arrows, MatrixZero, StochAngle, StochCloseOpen, StochCrossSignal, StochCrossOverSBL, SignalCrossOverSBL, IndexCrossStoch, IndexCrossSignal, IndexCrossOverSBL };   
         
        if (ShowArrows==MatrixZero)
         {
          if (MatrixDN[i+1] !=EMPTY_VALUE && MatrixDN[i+2] ==EMPTY_VALUE)   manageArr(i,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (MatrixUP[i+1] !=EMPTY_VALUE && MatrixUP[i+2] ==EMPTY_VALUE)   manageArr(i,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
         
        if (ShowArrows==StochAngle)
         {
          if (ExtBufferDN[i+1] !=0 && ExtBufferDN[i+2] ==0)   manageArr(i,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (ExtBufferUP[i+1] !=0 && ExtBufferUP[i+2] ==0)   manageArr(i,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
         
        if (ShowArrows==StochCloseOpen)
         {
          if (CLDN[i+1] !=0 && CLDN[i+2] ==0)   manageArr(i,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (CLUP[i+1] !=0 && CLUP[i+2] ==0)   manageArr(i,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
         
        if (ShowArrows==StochCrossSignal)
         {
          if (Buf7[i+1] < SignalBuffer[i+1] && Buf7[i+2] > SignalBuffer[i+2])   manageArr(i,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (Buf7[i+1] > SignalBuffer[i+1] && Buf7[i+2] < SignalBuffer[i+2])   manageArr(i,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
         
        if (ShowArrows==StochCrossOverSBL)
         {
          if (Buf7[i+1] < OverBought && Buf7[i+2] > OverBought)   manageArr(i,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (Buf7[i+1] > OverSold   && Buf7[i+2] < OverSold)     manageArr(i,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
         
        if (ShowArrows==SignalCrossOverSBL)
         {
          if (SignalBuffer[i+1] < OverBought && SignalBuffer[i+2] > OverBought)   manageArr(i,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (SignalBuffer[i+1] > OverSold   && SignalBuffer[i+2] < OverSold)     manageArr(i,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
         
        if (ShowArrows==IndexCrossStoch)
         {
          if (IndexBuffer[i+1] < Buf7[i+1] && IndexBuffer[i+2] > Buf7[i+2])   manageArr(i,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (IndexBuffer[i+1] > Buf7[i+1] && IndexBuffer[i+2] < Buf7[i+2])   manageArr(i,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
         
        if (ShowArrows==IndexCrossSignal)
         {
          if (IndexBuffer[i+1] < SignalBuffer[i+1] && IndexBuffer[i+2] > SignalBuffer[i+2])   manageArr(i,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (IndexBuffer[i+1] > SignalBuffer[i+1] && IndexBuffer[i+2] < SignalBuffer[i+2])   manageArr(i,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
         
        if (ShowArrows==IndexCrossOverSBL)
         {
          if (IndexBuffer[i+1] < OverBought && IndexBuffer[i+2] > OverBought)   manageArr(i,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (IndexBuffer[i+1] > OverSold   && IndexBuffer[i+2] < OverSold)     manageArr(i,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
//+++======================================================================+++
//+++           Stochastic-X8.4 vs Index +Matrix TT [x15x9x15]             +++
//+++======================================================================+++

  if (ShowArrows==StochCrossOverSBL || ShowArrows==SignalCrossOverSBL || ShowArrows==IndexCrossOverSBL)
   {        
    if (AlertsMessage || AlertsEmail || AlertsMobile || AlertsSound) 
     {
       if (ShowArrows==StochCrossOverSBL)   { First1[i+1]=Buf7[i+1]; First2[i+2]=Buf7[i+2]; }
       if (ShowArrows==SignalCrossOverSBL)  { First1[i+1]=SignalBuffer[i+1]; First2[i+2]=SignalBuffer[i+2]; }
       if (ShowArrows==IndexCrossOverSBL)   { First1[i+1]=IndexBuffer[i+1]; First2[i+2]=IndexBuffer[i+2]; }
       
       string messageL;
       if (TimeBar!=Time[0] && (First1[1] < OverBought && First2[2] > OverBought)) 
        {
         messageL =("StochX8 +Matrix TT - "+Symbol()+", TF ["+IntegerToString(Period())+"] = "+EnumToString(ShowArrows)+" <<<  Arrow DN  ==  SELL");   //BearsBulls Alerts MTF TT
         if (AlertsMessage) Alert(messageL);
         if (AlertsEmail)   SendMail(Symbol(),messageL);
         if (AlertsMobile)  SendNotification(messageL);
         if (AlertsSound)   PlaySound(SoundFile);   //"stops.wav"   //"news.wav"
         TimeBar=Time[0];
         //return(0);
        } 
          
       else if (TimeBar!=Time[0] && (First1[1] > OverSold && First2[2] < OverSold)) 
        { 
         messageL =("StochX8 +Matrix TT - "+Symbol()+", TF ["+IntegerToString(Period())+"] = "+EnumToString(ShowArrows)+" >>>  Arrow UP  ==  BUY");   //BearsBulls Alerts MTF TT
         if (AlertsMessage) Alert(messageL);
         if (AlertsEmail)   SendMail(Symbol(),messageL);
         if (AlertsMobile)  SendNotification(messageL);
         if (AlertsSound)   PlaySound(SoundFile);   //"stops.wav"   //"news.wav"
         TimeBar=Time[0];
         //return(0);
        }
      }
   } 
//+++======================================================================+++
//+++======================================================================+++

  if (ShowArrows==MatrixZero || ShowArrows==StochAngle || ShowArrows==StochCloseOpen || ShowArrows==StochCrossSignal || ShowArrows==IndexCrossStoch || ShowArrows==IndexCrossSignal)
   {        
    if (AlertsMessage || AlertsEmail || AlertsMobile || AlertsSound) 
     {
       if (ShowArrows==MatrixZero)         { First1[i+1]=MatrixDN[i+1]; First2[i+2]=MatrixDN[i+2]; Secnd1[i+1]=MatrixUP[i+1]; Secnd2[i+2]=MatrixUP[i+2]; }
       if (ShowArrows==StochAngle)         { First1[i+1]=ExtBufferUP[i+1]; First2[i+2]=ExtBufferUP[i+2]; Secnd1[i+1]=ExtBufferDN[i+1]; Secnd2[i+2]=ExtBufferDN[i+2]; }
       if (ShowArrows==StochCloseOpen)     { First1[i+1]=CLUP[i+1]; First2[i+2]=CLUP[i+2]; Secnd1[i+1]=CLDN[i+1]; Secnd2[i+2]=CLDN[i+2]; }
       if (ShowArrows==StochCrossSignal)   { First1[i+1]=Buf7[i+1]; First2[i+2]=Buf7[i+2]; Secnd1[i+1]=SignalBuffer[i+1]; Secnd2[i+2]=SignalBuffer[i+2]; }
       if (ShowArrows==IndexCrossStoch)    { First1[i+1]=IndexBuffer[i+1]; First2[i+2]=IndexBuffer[i+2]; Secnd1[i+1]=SignalBuffer[i+1]; Secnd2[i+2]=SignalBuffer[i+2]; }
       if (ShowArrows==IndexCrossSignal)   { First1[i+1]=IndexBuffer[i+1]; First2[i+2]=IndexBuffer[i+2]; Secnd1[i+1]=SignalBuffer[i+1]; Secnd2[i+2]=SignalBuffer[i+2]; }
       
       string message;
       if (TimeBar!=Time[0] && (First1[1] < Secnd1[1] && First2[2] > Secnd2[2])) 
        {
         message =("StochX8 +Matrix TT - "+Symbol()+", TF ["+IntegerToString(Period())+"] = "+EnumToString(ShowArrows)+" <<<  Arrow DN  ==  SELL");   //BearsBulls Alerts MTF TT
         if (AlertsMessage) Alert(message);
         if (AlertsEmail)   SendMail(Symbol(),message);
         if (AlertsMobile)  SendNotification(message);
         if (AlertsSound)   PlaySound(SoundFile);   //"stops.wav"   //"news.wav"
         TimeBar=Time[0];
         //return(0);
        } 
          
       else if (TimeBar!=Time[0] && (First1[1] > Secnd1[1] && First2[2] < Secnd2[2])) 
        { 
         message =("StochX8 +Matrix TT - "+Symbol()+", TF ["+IntegerToString(Period())+"] = "+EnumToString(ShowArrows)+" >>>  Arrow UP  ==  BUY");   //BearsBulls Alerts MTF TT
         if (AlertsMessage) Alert(message);
         if (AlertsEmail)   SendMail(Symbol(),message);
         if (AlertsMobile)  SendNotification(message);
         if (AlertsSound)   PlaySound(SoundFile);   //"stops.wav"   //"news.wav"
         TimeBar=Time[0];
         //return(0);
        }
      }
   } 
//+++======================================================================+++
//+++======================================================================+++
       }     
//----
return(0);
}
//+++======================================================================+++
//+++           Stochastic-X8.4 vs Index +Matrix TT [x15x9x15]             +++
//+++======================================================================+++

void manageArr(int z, string text, color Clr, int Code, int Size, bool DN)   
{
   string objName = "Stoch ["+IntegerToString(Stoch_K)+","+IntegerToString(Stoch_S)+"] vs "+EnumToString(ShowIndex)+" ["+IntegerToString(IndexPeriod)+"]_"+text+"_"+Time[z]+"_"+Close[z];
   //double Gap = 2.0*iATR(NULL,0,20,z)/4.0;
   double Gap=ArrowGap*Point;   if (Digits==3 || Digits==5) Gap=ArrowGap*10*Point;
   
   ObjectCreate(objName, OBJ_ARROW,0,Time[z],0);
   ObjectSet   (objName, OBJPROP_TEXT, text);  
   ObjectSet   (objName, OBJPROP_COLOR, Clr);  
   ObjectSet   (objName, OBJPROP_ARROWCODE,Code);
   ObjectSet   (objName, OBJPROP_WIDTH,Size);  
   
   if (DN)
      ObjectSet(objName,OBJPROP_PRICE1,High[z]+Gap*1.3);   
      
     else  
      ObjectSet(objName,OBJPROP_PRICE1,Low[z] -Gap);
}
//+++======================================================================+++
//+++           Stochastic-X8.4 vs Index +Matrix TT [x15x9x15]             +++
//+++======================================================================+++
//+++======================================================================+++